// --- L-System Parser/Mutator --- Lj Lapre --- 
// use with output[1-7].inc generated by lparser -Bc
// and change direction/zoom scale to get correct view

// Modified by Robert_Gasch@peoplesoft.com to allow
// for automatic scaling through LPEvol. Changing
// any of the uppercase tokens below will break LPEvol!!!


#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"

// Choose 8 colors

#declare col_0  = colour red 1.0 green 1.0 blue 1.0
#declare col_1  = colour red 0.8 green 0.498039 blue 0.196078
#declare col_2  = colour red 1.0
#declare col_3  = colour red 1.0 green 1.0
#declare col_4  = colour green 1.0
#declare col_5  = colour blue 1.0 green 1.0
#declare col_6  = colour blue 1.0
#declare col_7  = colour red 1.0 blue 1.0

// Setup camera

camera {
	//location	<200, 180, 250>
	location	<0, 0.75, -6>
	direction	<0, 0, 2.0>
	// look_at	<0, 0.75, 0>
	look_at		<LSLOOKAT_X, LSLOOKAT_Y+0.5, LSLOOKAT_Z>
}

// Setup light sources
object { light_source { <20, 5, -25> color White } }
object { light_source { <-30, 5, -25> color White } }

#declare LSYS_MBLOB_OBJ =
union 
{
	object {  
		blob {
			threshold 0.5
			#include "output0.inc"
			sturm
			}
		finish { ambient 0.3 diffuse 0.7 phong 1 }
		pigment { color col_0 }
		}

	object {  
		blob {
			threshold 0.5
			#include "output1.inc"
			sturm
			}
		finish { ambient 0.3 diffuse 0.7 phong 1 }
		pigment { color col_1 }
		}

	object {  
		blob {
			threshold 0.5
			#include "output2.inc"
			sturm
			}
		finish { ambient 0.3 diffuse 0.7 phong 1 }
		pigment { color col_2 }
		}

	object {  
		blob {
			threshold 0.5
			#include "output3.inc"
			sturm
			}
		finish { ambient 0.3 diffuse 0.7 phong 1 }
		pigment { color col_3 }
		}

	object {  
		blob {
			threshold 0.5
			#include "output4.inc"
			sturm
        		}
		finish { ambient 0.3 diffuse 0.7 phong 1 }
		pigment { color col_4 }
		}

	object {  
		blob {
			threshold 0.5
			#include "output5.inc"
			sturm
			}
		finish { ambient 0.3 diffuse 0.7 phong 1 }
		pigment { color col_5 }
		}

	object {  
		blob {
			threshold 0.5
			#include "output6.inc"
			sturm
			}
		finish { ambient 0.3 diffuse 0.7 phong 1 }
		pigment { color col_6 }
		}

	object {  
		blob {
			threshold 0.5
			#include "output7.inc"
			sturm
        		}
		finish { ambient 0.3 diffuse 0.7 phong 1 }
		pigment { color col_7 }
		}
}

object { LSYS_MBLOB_OBJ scale <LSSCALEX, LSSCALEY*2, LSSCALEZ>}

