/* ************************************************************************* *
   JAC - (C) Copyright 1998 Robert Gasch (Robert_Gasch@peoplesoft.com)
	     http://www.peoplesoft.com/peoplepages/g/robert_gasch/index.htm

   Permission to use, copy, modify and distribute this software for any 
   purpose and without fee is hereby granted, provided that this copyright
   notice appear in all copies as well as supporting documentation. All
   work developed as a consequence of the use of this program should duly
   acknowledge such use.

   No representations are made about the suitability of this software for
   any purpose. This software is provided "as is" without express or implied 
   warranty.

   See the GNU General Public Licence for more information.
 * ************************************************************************* */


import java.lang.*;
import java.awt.*;
import java.awt.event.ActionListener;


/* ************************************************************************** */
/* *** JAC_DialogYNC: Creates a dialog with 3 (OK, Apply, Cancel) buttons *** */
/* ************************************************************************** */
public class JAC_DialogOAC extends Dialog
{
	private ActionListener 	d_CallbackDest=null;
	private	Panel		d_Panel=null;
	private String 		d_Message=null; 
	private boolean		d_modal=false;

	/** Constructor: create a modal(blocking) dialog */
	public JAC_DialogOAC (ActionListener CallbackDest, String Message)
		{
		this (CallbackDest, Message, true);
		}

	/** Constructor: create dialog accoring to the parameters */
	public JAC_DialogOAC (ActionListener CallbackDest, String Message, boolean modal) 
		{
		super (new Frame(), modal);

		d_CallbackDest = CallbackDest;
		d_Message = Message;
		d_modal = modal;

		init ();
		}

	/** init: create the actual dialog, doesn't include calling show() */
	private void init ()
		{
		Button		Btn1, Btn2, Btn3;

		if (d_Message != null)
			this.add ("Center", new Label(d_Message));
		d_Panel = new Panel ();
		d_Panel.setLayout (new FlowLayout());

		Btn1 = new Button ("OK");
		Btn1.addActionListener (d_CallbackDest);
		d_Panel.add (Btn1);

		Btn2 = new Button ("Apply");
		Btn2.addActionListener (d_CallbackDest);
		d_Panel.add (Btn2);

		Btn3 = new Button ("Cancel");
		Btn3.addActionListener (d_CallbackDest);
		d_Panel.add (Btn3);

		this.add ("South", d_Panel);
		this.setSize (300,100);
		this.setLocation (100, 200);
		}
}

