/* ************************************************************************* *
   JAC - (C) Copyright 1998 Robert Gasch (Robert_Gasch@peoplesoft.com)
	     http://www.peoplesoft.com/peoplepages/g/robert_gasch/index.htm

   Permission to use, copy, modify and distribute this software for any 
   purpose and without fee is hereby granted, provided that this copyright
   notice appear in all copies as well as supporting documentation. All
   work developed as a consequence of the use of this program should duly
   acknowledge such use.

   No representations are made about the suitability of this software for
   any purpose. This software is provided "as is" without express or implied 
   warranty.

   See the GNU General Public Licence for more information.
 * ************************************************************************* */


import java.lang.*;
import java.awt.*;
import java.awt.event.ActionListener;


/* ************************************************************************** */
/* ******** JAC_DialogYN: Creates a dialog with 2 (Yes, No) buttons ********* */
/* ************************************************************************** */
public class JAC_DialogYN extends Dialog
{
	ActionListener 	d_CallbackDest=null;
	String 		d_Message=null; 
	boolean		d_modal=false;

	/** Constructor: create a modal(blocking) dialog */
	public JAC_DialogYN (ActionListener CallbackDest, String Message)
		{
		this (CallbackDest, Message, true);
		}

	/** Constructor: create dialog accoring to the parameters */
	public JAC_DialogYN (ActionListener CallbackDest, String Message, boolean modal) 
		{
		super (new Frame(), modal);

		d_CallbackDest = CallbackDest;
		d_Message = Message;
		d_modal = modal;

		init ();
		}

	/** init: create the actual dialog, doesn't include calling show() */
	private void init ()
		{
		Panel   	Pnl;
		Button		Btn1, Btn2;

		this.add ("Center", new Label(d_Message));
		Pnl = new Panel();
		Pnl.setLayout (new FlowLayout());

		Btn1 = new Button ("Yes");
		Btn1.addActionListener (d_CallbackDest);
		Pnl.add (Btn1);

		Btn2 = new Button ("No");
		Btn2.addActionListener (d_CallbackDest);
		Pnl.add (Btn2);

		this.add ("South", Pnl);
		this.setSize (300,100);
		this.setLocation (100, 200);
		}
}

