/* ************************************************************************* *
   JAC - (C) Copyright 1998 Robert Gasch (Robert_Gasch@peoplesoft.com)
             http://www.peoplesoft.com/peoplepages/g/robert_gasch/index.htm

   Permission to use, copy, modify and distribute this software for any 
   purpose and without fee is hereby granted, provided that this copyright
   notice appear in all copies as well as supporting documentation. All
   work developed as a consequence of the use of this program should duly
   acknowledge such use.

   No representations are made about the suitability of this software for
   any purpose. This software is provided "as is" without express or implied 
   warranty.

   See the GNU General Public Licence for more information.
 * ************************************************************************* */


import java.lang.*;
import java.io.*;
import java.util.*;


/* ************************************************************************** */
/* ************** JAC_FileWriter: add a vectorized file writer ************** */
/* ************************************************************************** */
public class JAC_FileWriter extends BufferedWriter
{
	public final int	MAXSTRINGSIZE=255;

	private int		d_maxsize=MAXSTRINGSIZE;
	private boolean		d_ignore_blanks=false;

	/** Constructor: call FileWriter constructor with filename */
	public JAC_FileWriter (String fname) throws FileNotFoundException, 
						    IOException 
		{
		super (new FileWriter (fname));
		if (JAC_GlobalDebug.debug() > 0)
			System.out.println ("Writing: " + fname);
		}

	/** Constructor: call FileWriter constructor with filename */
	public JAC_FileWriter (String Dir, String Fle) throws 
						 	FileNotFoundException, 
							IOException 
		{
		super (new FileWriter (new File (Dir, Fle)));
		if (JAC_GlobalDebug.debug() == 0)
			System.out.println ("Writing: " + Dir + "/" + Fle);
		}

	 /** finalize: let destructor close the file */
	protected void finalize() throws Throwable 
		{
		this.close ();
		}

	/** writeList: write a list and don't add a return to every line */
	public int write (Vector VList)
		{
		return (write (VList, false));
		}

	/** writeList: write a list (1 entry per line)  */
	public int write (Vector VList, boolean add_return)
		{
		int		lim=VList.size();
		String		Line=null;

		try {
		    for (int i=0; i<lim; i++)
			{
			if (add_return)
				Line = ((String)VList.elementAt(i)).concat("\n");
			else
				Line = (String)VList.elementAt(i);
			this.write (Line, 0, Line.length());
			}
		    }
		catch (IOException e)
		    {
		    System.out.println ("Caught IOException in JAC_FileWriter::readList () ...");
		    return (-1);
		    }
			
		return (0);
		}
}


