/* ************************************************************************* *
   JAC - (C) Copyright 1998 Robert Gasch (Robert_Gasch@peoplesoft.com)
	     http://www.peoplesoft.com/peoplepages/g/robert_gasch/index.htm

   Permission to use, copy, modify and distribute this software for any 
   purpose and without fee is hereby granted, provided that this copyright
   notice appear in all copies as well as supporting documentation. All
   work developed as a consequence of the use of this program should duly
   acknowledge such use.

   No representations are made about the suitability of this software for
   any purpose. This software is provided "as is" without express or implied 
   warranty.

   See the GNU General Public Licence for more information.
 * ************************************************************************* */


import java.lang.*;
import java.io.*;


/* ************************************************************************** */
/* **** JAC_GlobalDebug: Provides a static (global) debug flag mechanism **** */
/* ************************************************************************** */
class JAC_GlobalDebug extends JAC_GlobalVerbose
{
	private static int		d_debug=0;
	private static final int	d_maxdebuglevels=3;

	/** Constructor: Initialize debug accordingly */
	JAC_GlobalDebug (int debug)
		{
		debug (debug);
		}

	/** debug: Assign a maximum of maxdebuglevels debug levels 
	    and call verbose() accordingly 
	**/
	public static void debug (int debug)
		{
		if (debug < 0 || debug > d_maxdebuglevels)
			return;

		d_debug=debug;
		if (d_debug > 0)
			verbose (true);
		else
			verbose (false);
		}

	/** debug: return current debug level */
	public static int debug ()
		{
		return (d_debug);
		}
}

