/* ************************************************************************* *
   JAC - (C) Copyright 1998 Robert Gasch (Robert_Gasch@peoplesoft.com)
	     http://www.peoplesoft.com/peoplepages/g/robert_gasch/index.htm

   Permission to use, copy, modify and distribute this software for any 
   purpose and without fee is hereby granted, provided that this copyright
   notice appear in all copies as well as supporting documentation. All
   work developed as a consequence of the use of this program should duly
   acknowledge such use.

   No representations are made about the suitability of this software for
   any purpose. This software is provided "as is" without express or implied 
   warranty.

   See the GNU General Public Licence for more information.
 * ************************************************************************* */


import java.lang.*;
import java.io.*;
import java.util.*;


/* *********************************************************************** */
/* ****** JAC_ResFile: parse a resource file with syntax "key=val" ******* */
/* *********************************************************************** */
public class JAC_ResFile extends JAC_FileReader
{
	private	Vector		d_VKey = new Vector (5, 5),
				d_VValue = new Vector (5, 5);

	/** main: for standalone use/testing */
        public static void main (String[] args)
		{
		JAC_ResFile	JRes = null;

		if (args.length == 1)
			JRes = new JAC_ResFile (args[0]); 
		else
			{
			System.err.println ("Usage: JAC_ResFile <resource_file>");
			System.exit (1);
			}

		}

	/** Constructor: read filename through Superclass and set name */
	public JAC_ResFile (String Fname) throws FileNotFoundException, 
						 IOException
		{
		super (Fname);
		}

	/** Print: print the [Key,Value] pairs  */
	public void Print ()
		{
		int	lim = d_VKey.size();

		for (int i=0; i<lim; i++)
			System.out.println ((String)(d_VKey.elementAt(i))+", "+
					    (String)(d_VKey.elementAt(i)));
		}

	/** Key: return the specified Key */
	public String Key (int n)
		{
		String 	Key = (String)d_VKey.elementAt(n);

		return (Key);
		}

	/** Value: return the specified value */
	public String Value (int n)
		{
		String 	Val = (String)d_VValue.elementAt(n);

		return (Val);
		}

	/** Read: read the file and parse the "key=val" expressions */
	public int Read ()
		{
		int		ti=0,
				c=0,
				lim;
		String		Line, 
				Skey, Sval;
		Vector		VLine = null;
		StringTokenizer	St = null;

		// read entire file in 1 go
		VLine = this.readList (0, null, "//");
		lim = VLine.size();

		for (int i=0; i<lim; i++)
			{
			Line = (String)VLine.elementAt (i);
			St = new StringTokenizer (Line, "=");
			Skey = St.nextToken ();
			Sval = St.nextToken ();

			if (St.hasMoreTokens () ||
			    Skey.length() == 0 	|| 
			    Sval.length() == 0 	)
				{
				System.err.println ("Syntax Error: " + Line);
				return (-1);
				}
			else
				{
				d_VKey.addElement (Skey);
				d_VValue.addElement (Sval);
				}
			}

	return (0);
	}
}


