/* ************************************************************************* *
   JAC - (C) Copyright 1998 Robert Gasch (Robert_Gasch@peoplesoft.com)
	     http://www.peoplesoft.com/peoplepages/g/robert_gasch/index.htm

   Permission to use, copy, modify and distribute this software for any 
   purpose and without fee is hereby granted, provided that this copyright
   notice appear in all copies as well as supporting documentation. All
   work developed as a consequence of the use of this program should duly
   acknowledge such use.

   No representations are made about the suitability of this software for
   any purpose. This software is provided "as is" without express or implied 
   warranty.

   See the GNU General Public Licence for more information.
 * ************************************************************************* */


import java.awt.*;
import java.awt.Frame;
import java.awt.event.*;
import java.awt.MenuShortcut;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.Properties;
import java.awt.datatransfer.*;


/* *********************************************************************** */
/* *** JAC_SimpleBufferEdit: extend SimpleTextEdit to work on a buffer *** */
/* *********************************************************************** */
public class JAC_SimpleBufferEdit extends JAC_SimpleTextEdit 
{
	/** Constructor: assign buffer */
	public JAC_SimpleBufferEdit (char[] buf)
		{
		this (buf, 0);
		}

	/** Constructor: assign buffer */
	public JAC_SimpleBufferEdit (char[] buf, int max)
		{
		super ();
		this.d_Name = new String ("Untitled.txt");
		this.d_charbuf = true;

		if (max > 0)
			this.d_Ta.setText (new String (buf, 0, max));
		else
			this.d_Ta.setText (new String (buf));

		this.d_Ta.select (0,0);
		this.d_Name = new String ();
		this.d_Frame.setTitle ("SimpleTextEdit: Character buffer");
		}

	/** close: close the editor and return the buffer */
	public String close ()
		{
		String SBuf = this.d_Ta.getText();
		this.d_Frame.dispose ();
		return (SBuf);
		}
}

