/* ************************************************************************* * 
   LPEvol - (C) Copyright 1998 Robert Gasch (Robert_Gasch@peoplesoft.com)
	        http://www.peoplesoft.com/peoplepages/g/robert_gasch/index.htm

   Permission to use, copy, modify and distribute this software for any 
   purpose and without fee is hereby granted, provided that this copyright
   notice appear in all copies as well as supporting documentation. All
   work developed as a consequence of the use of this program should duly
   acknowledge such use.

   No representations are made about the suitability of this software for
   any purpose. This software is provided "as is" without express or implied 
   warranty.

   See the GNU General Public Licence for more information.
 * ************************************************************************* */


import java.awt.*;
import java.awt.event.*;


/* ************************************************************************** */
/* ********** LPEGuiOptions: Provides a GUI options panel for LPEVol ******** */
/* ************************************************************************** */
public class LPEGuiOptions extends Dialog { 

	// Breeding controls
	Label 			d_labelHeadingBreed;
	Checkbox 		d_checkboxCrossBefore;
	Label 			d_label1;
	Checkbox 		d_checkboxBreedAxiom;
	Label 			d_label2;
	TextField 		d_textFieldAppendChromosome;
	Label 			d_label3;
	TextField 		d_textFieldAppendReplace;
	Label 			d_label4;
	TextField 		d_textFieldNumberBreed;
	Label 			d_lebel5;
	TextField 		d_textFieldMutate;
	Label 			d_label6;
	Choice 			d_choiceLimitBrackets;
	Label 			d_label7;

	// Render controls
	Label 			d_labelHeadingRender;
	TextField 		d_textFieldMinInclude;
	Label 			d_label8;
	TextField 		d_textFieldMaxInclude;
	Label 			d_label9;
	Choice 			d_choiceRenderMode;
	Label 			d_label10;

	// Global controls
	Label 			d_labelHeadingGlobal;
	Checkbox 		d_checkboxCleanupFiles;
	Label 			d_label11;
	Checkbox 		d_checkboxDirectories;
	Label 			d_label12;
	Checkbox 		d_checkboxRecycleImages;
	Label 			d_label13;

	Button 			d_buttonOK;
	Button 			d_buttonCancel;
	

	public LPEGuiOptions(Frame parent, boolean modal) 
		{
		super (parent, modal);
		init ();
		}

	public void init ()
		{
		setLayout(null);
		//addNotify();
		setSize (getInsets().left + getInsets().right + 435,getInsets().top + getInsets().bottom + 590);

		// Breeding Options
		d_labelHeadingBreed = new Label(" Breed Options");
		d_labelHeadingBreed.setBounds(getInsets().left + 24,getInsets().top + 36,84,24);
		add(d_labelHeadingBreed);

		d_checkboxCrossBefore = new Checkbox("");
		d_checkboxCrossBefore.setBounds(getInsets().left + 108,getInsets().top + 72,15,16);
		add(d_checkboxCrossBefore);
		d_label1 = new Label("Shift left when guessing a number ");
		d_label1.setBounds(getInsets().left + 132,getInsets().top + 72,264,16);
		add(d_label1);

		d_checkboxBreedAxiom = new Checkbox("");
		d_checkboxBreedAxiom.setBounds(getInsets().left + 108,getInsets().top + 96,15,16);
		add(d_checkboxBreedAxiom);
		d_label2 = new Label("Breed Axiom");
		d_label2.setBounds(getInsets().left + 132,getInsets().top + 96,144,16);
		add(d_label2);

		d_textFieldAppendChromosome = new TextField();
		d_textFieldAppendChromosome.setBounds(getInsets().left + 72,getInsets().top + 120,50,24);
		d_textFieldAppendChromosome.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(d_textFieldAppendChromosome);
		d_label3 = new Label("Append Chromosome Probability (0..1)");
		d_label3.setBounds(getInsets().left + 132,getInsets().top + 120,276,16);
		add(d_label3);

		d_textFieldAppendReplace = new TextField();
		d_textFieldAppendReplace.setBounds(getInsets().left + 72,getInsets().top + 144,50,24);
		d_textFieldAppendReplace.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(d_textFieldAppendReplace);
		d_label4 = new Label("Replace original references after append (0..1)");
		d_label4.setBounds(getInsets().left + 132,getInsets().top + 144,276,16);
		add(d_label4);

		d_textFieldNumberBreed = new TextField();
		d_textFieldNumberBreed.setBounds(getInsets().left + 72,getInsets().top + 168,50,24);
		d_textFieldNumberBreed.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(d_textFieldNumberBreed);
		d_lebel5 = new Label("Number Breed Probability (0 ..1)");
		d_lebel5.setBounds(getInsets().left + 132,getInsets().top + 168,228,16);
		add(d_lebel5);

		d_textFieldMutate = new TextField();
		d_textFieldMutate.setBounds(getInsets().left + 72,getInsets().top + 192,50,24);
		d_textFieldMutate.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(d_textFieldMutate);
		d_label6 = new Label("Number of Times (for LParser) to mutate ");
		d_label6.setBounds(getInsets().left + 132,getInsets().top + 192,276,16);
		add(d_label6);

		d_choiceLimitBrackets = new Choice();
		d_choiceLimitBrackets.addItem("Off");
		d_choiceLimitBrackets.addItem("All");
		d_choiceLimitBrackets.addItem("Left");
		d_choiceLimitBrackets.addItem("Right");
		add(d_choiceLimitBrackets);
		d_choiceLimitBrackets.setBounds(getInsets().left + 36,getInsets().top + 216,84,21);
		d_choiceLimitBrackets.setFont(new Font("Dialog", Font.PLAIN, 10));
		d_label7 = new Label("Limit Brackets Mode");
		d_label7.setBounds(getInsets().left + 132,getInsets().top + 216,168,16);
		add(d_label7);

		//vLine1 = new JAC_VLine(getInsets().left + 12,getInsets().top + 48);
		//vLine1.reshape(2,204);
		//add(vLine1);
		//hLine1 = new JAC_HLine(getInsets().left + 108,getInsets().top + 48);
		//hLine1.reshape(312,2);
		//add(hLine1);
		//vLine2 = new JAC_VLine(getInsets().left + 420,getInsets().top + 48);
		//vLine2.reshape(2,204);
		//add(vLine2);
		//hLine2 = new JAC_HLine(getInsets().left + 12,getInsets().top + 252);
		//hLine2.reshape(408,2);
		//add(hLine2);
		//hLine3 = new JAC_HLine(getInsets().left + 12,getInsets().top + 48);
		//hLine3.reshape(2,2);
		//add(hLine3);


		// Render Options
		d_labelHeadingRender = new Label(" Render Options");
		d_labelHeadingRender.setBounds(getInsets().left + 24,getInsets().top + 264,96,24);
		add(d_labelHeadingRender);

		d_textFieldMinInclude = new TextField();
		d_textFieldMinInclude.setBounds(getInsets().left + 48,getInsets().top + 300,74,24);
		d_textFieldMinInclude.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(d_textFieldMinInclude);
		d_label8 = new Label("Minimum Include file size (in bytes)");
		d_label8.setBounds(getInsets().left + 132,getInsets().top + 300,240,16);
		add(d_label8);

		d_textFieldMaxInclude = new TextField();
		d_textFieldMaxInclude.setBounds(getInsets().left + 48,getInsets().top + 324,74,24);
		d_textFieldMaxInclude.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(d_textFieldMaxInclude);
		d_label9 = new Label("Maximum Include File size (in bytes)");
		d_label9.setBounds(getInsets().left + 132,getInsets().top + 324,252,16);
		add(d_label9);

		d_choiceRenderMode = new Choice();
		d_choiceRenderMode.addItem("Triangle");
		d_choiceRenderMode.addItem("Blob");
		d_choiceRenderMode.addItem("Multi Blob");
		add(d_choiceRenderMode);
		d_choiceRenderMode.setBounds(getInsets().left + 24,getInsets().top + 348,96,21);
		d_choiceRenderMode.setFont(new Font("Dialog", Font.PLAIN, 10));
		d_label10 = new Label("PovRay Render Mode ");
		d_label10.setBounds(getInsets().left + 132,getInsets().top + 348,180,16);
		add(d_label10);

		//vLine3 = new JAC_VLine(getInsets().left + 12,getInsets().top + 276);
		//xvLine3.reshape(2,108);
		//add(vLine3);
		//hLine4 = new JAC_HLine(getInsets().left + 120,getInsets().top + 276);
		//hLine4.reshape(300,2);
		//add(hLine4);
		//vLine4 = new JAC_VLine(getInsets().left + 420,getInsets().top + 276);
		//vLine4.reshape(2,108);
		//add(vLine4);
		//hLine5 = new JAC_HLine(getInsets().left + 12,getInsets().top + 276);
		//hLine5.reshape(12,2);
		//add(hLine5);
		//hLine6 = new JAC_HLine(getInsets().left + 12,getInsets().top + 384);
		//hLine6.reshape(408,2);
		//nadd(hLine6);

		// Global Options
		d_labelHeadingGlobal = new Label(" Global Options");
		d_labelHeadingGlobal.setBounds(getInsets().left + 24,getInsets().top + 396,96,24);
		add(d_labelHeadingGlobal);

		d_checkboxCleanupFiles = new Checkbox("");
		d_checkboxCleanupFiles.setBounds(getInsets().left + 108,getInsets().top + 432,15,16);
		add(d_checkboxCleanupFiles);
		d_label11 = new Label("Cleanup Temporary Files");
		d_label11.setBounds(getInsets().left + 132,getInsets().top + 432,192,16);
		add(d_label11);

		d_checkboxDirectories = new Checkbox("");
		d_checkboxDirectories.setBounds(getInsets().left + 108,getInsets().top + 456,15,16);
		add(d_checkboxDirectories);
		d_label12 = new Label("Create Directory for each Population");
		d_label12.setBounds(getInsets().left + 132,getInsets().top + 456,264,16);
		add(d_label12);

		d_checkboxRecycleImages = new Checkbox("");
		d_checkboxRecycleImages.setBounds(getInsets().left + 108,getInsets().top + 480,15,16);
		add(d_checkboxRecycleImages);
		d_label13 = new Label("Attempt to re-use old population images");
		d_label13.setBounds(getInsets().left + 132,getInsets().top + 480,276,16);
		add(d_label13);

		//vLine5 = new JAC_VLine(getInsets().left + 12,getInsets().top + 408);
		//vLine5.reshape(2,108);
		//add(vLine5);
		//vLine6 = new JAC_VLine(getInsets().left + 420,getInsets().top + 408);
		//vLine6.reshape(2,108);
		//add(vLine6);
		//hLine7 = new JAC_HLine(getInsets().left + 120,getInsets().top + 408);
		//hLine7.reshape(300,2);
		//add(hLine7);
		//hLine8 = new JAC_HLine(getInsets().left + 12,getInsets().top + 408);
		//hLine8.reshape(12,2);
		//add(hLine8);
		//hLine9 = new JAC_HLine(getInsets().left + 12,getInsets().top + 516);
		//hLine9.reshape(408,2);
		//add(hLine9);

		// Buttons 
		d_buttonOK = new Button("OK");
		d_buttonOK.setBounds(getInsets().left + 276,getInsets().top + 540,56,30);
		add(d_buttonOK);
		d_buttonCancel = new Button("Cancel");
		d_buttonCancel.setBounds(getInsets().left + 96,getInsets().top + 540,56,30);
		add(d_buttonCancel);

		setTitle("LPEVol Options");
		setResizable(false);

		readOptions();

		this.show ();
		}

	public LPEGuiOptions (Frame parent, String title, boolean modal) 
		{
		this(parent, modal);
		setTitle(title);
		}

	private void readOptions ()
		{
		d_checkboxCrossBefore.setState (LPEOptions.s_crossBeforeNumber);
		//d_checkboxBreedAxiom.setState (LPEOptions.s_crossBeforeNumber);
		d_textFieldAppendChromosome.setText (Float.toString(LPEOptions.s_append));
		d_textFieldAppendReplace.setText (Float.toString(LPEOptions.s_appendReplace));
		d_textFieldNumberBreed.setText (Float.toString(LPEOptions.s_numberBreedProb));
		d_textFieldMutate.setText (Integer.toString(LPEOptions.s_mutate));
		d_choiceLimitBrackets.select (1);
		}

	private void writeOptions ()
		{
		}

	/** paint: repaint the dialog */
	public synchronized void paint (Graphics g) 
		{
    		Rectangle 	bounds = getParent().getBounds();
    		Rectangle 	abounds = this.getBounds();

    		this.setLocation (bounds.x + (bounds.width - abounds.width)/ 2,
    		     bounds.y + (bounds.height - abounds.height)/2);

    		super.show();
		}
}
